; ============================
;  Fellow Amiga Emulator      
;  Bus Event Scheduling
;  (C) 1997/1998 Petter Schau 
; ============================


        .586p
DGROUP group _DATA,_BSS
_TEXT  segment para public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

; Petter Schau 1997

public busstart_
busstart_:       ; Used to check code alignment
startlbl:


include defs.inc
include func\fellow.inc
include func\memory.inc
include func\68000.inc
include func\floppy.inc
include func\sound.inc
include func\inout.inc
include func\joymouse.inc
include func\copper.inc
include func\cianew.inc
include func\draw.inc
include func\blit.inc
include func\graphem.inc
include func\BMP.inc
			
include mac\memory.mac
include mac\drawmode.mac
include mac\keyboard.mac
include mac\bus.mac
include mac\68000.mac

include def\sound.inc

#ifdef TEST_EVENTS_SANITY
extern events_messed_up_:near
#endif

		ALIGN32
	
public cpuExecuteNext_
cpuExecuteNext_:pushad
		EXEC_NEXT_68K
		popad
		ret
	
	
		
;===========================================================
; bus_run_
; The entrypoint to the emulation when no debugging is done.
; No trace-bit is tested, if updatesr detects a tracebit set
; it will modify the stack so the 68k emu returns to a
; routine that does. (Nasty hack....)
;===========================================================


                        ALIGN32

public bus_run_
bus_run_:               pushad
                        call    bus_run
                        popad
                        ret


bus_run:                SETUP_EXCEPTION_HACK bus_exception_ret, bus_loop_events
                        test    byte ptr [_sr + 1], 0c0h
                        jnz     bus_cpu_trace_start
			cmp	dword ptr [_cpu_next],-1
			je	bus_loop_events
                        jmp     bus_loop_cpu

                        ALIGN32

public checkadr_
checkadr_:
bus_loop_cpu:
	
#ifdef DEBUGBUILD
; Trace log code, not CPU trace bit handling, just CPU history
                        cmp     dword ptr _cputraceflag,1
                        jne     notrace

#ifdef CPU_TRACE_TO_FILE
			pushad
			call	cpu_trace_to_file_
			popad
#endif
                        mov     ecx,dword ptr _cputraceptr
                        and     ecx,07ffffh
                        inc     dword ptr _cputracecount
                        inc     dword ptr _cputraceptr
                        mov     edx,dword ptr _pc
                        mov     dword ptr _cputracebuffer[4*ecx],edx
#ifdef PC_PTR
	                mov     edx,dword ptr _pcbaseadr
                        mov     dword ptr _cputracebase[4*ecx],edx
#endif
notrace:
#endif
                        SET_POSITION_FULL _cpu_next
                        EXEC_NEXT_68K
			mov	ecx, dword ptr [_config_cpu_speed]
                        shr     eax, cl
                        add     eax,dword ptr _thiscycle
bus_exception_ret:      mov     dword ptr _thiscycle,0
                        add     eax,dword ptr [_curcycle]
                        mov     dword ptr [_cpu_next],eax
			TEST_SANITY
                        NEXT_EVENT_AFTER_CPU bus_loop_cpu, bus_loop_events
bus_exit:               ret

                        ALIGN32
bus_loop_events:	TEST_SANITY
		        NEXT_EVENT bus_loop_cpu


;===============================================================
; Routines called when cpu is in tracemode
; When updatesr detects that the cpu has been set in trace-mode
; it switches to these stubs.
; It will run any events in between, and then
;===============================================================


bus_loop_cpu_trace:

                        test    byte ptr [_debugging],1
                        jnz     bus_exit

bus_cpu_trace_start:
#ifdef DEBUGBUILD
; Trace log code, not CPU trace bit handling, just cpu history
                        cmp     dword ptr _cputraceflag,1
                        jne     notrace1
                        mov     ecx,dword ptr _cputraceptr
                        and     ecx,07ffffh
                        inc     dword ptr _cputracecount
                        inc     dword ptr _cputraceptr
                        mov     edx,dword ptr _pc
                        mov     dword ptr _cputracebuffer[4*ecx],edx
#ifdef PC_PTR
                        mov     edx,dword ptr _pcbaseadr
                        mov     dword ptr _cputracebase[4*ecx],edx
#endif
notrace1:
#endif
                        SET_POSITION_FULL _cpu_next
                        EXEC_NEXT_68K_TRACE
public bus_trace_mode
bus_trace_mode:         mov     dword ptr [_pc],esi
			mov	ecx, dword ptr [_config_cpu_speed]
                        shr     eax, cl
                        add     eax,dword ptr [_thiscycle]
                        mov     dword ptr [_thiscycle],0
                        add     eax,dword ptr [_curcycle]
                        mov     dword ptr [_cpu_next],eax
                        NEXT_EVENT_AFTER_CPU bus_loop_cpu_trace, bus_loop_events_trace
                        ret

                        ALIGN32
bus_loop_events_trace:  NEXT_EVENT bus_loop_cpu_trace


;===========================================================
; bus_debug_
; The entrypoint to the emulation when debugging is done.
; Tests trace bit, too.
; The switch is performed by updatesr.
;===========================================================


                        ALIGN32

public bus_debug_
bus_debug_:             pushad
                        call    bus_debug
                        popad
                        ret


bus_debug:              SETUP_EXCEPTION_HACK bus_debug_exception_ret, bus_debug_loop_events
			cmp	dword ptr [_cpu_next], -1
			je	bus_debug_loop_events_start
                        jmp     bus_debug_start

                        ALIGN32

bus_debug_loop_cpu:

                        test    byte ptr [_debugging], 1
                        jnz     bus_exit
bus_debug_start:

#ifdef DEBUGBUILD
; Trace log code, not CPU trace bit handling, just cpu history
                        cmp     dword ptr _cputraceflag,1
                        jne     notrace2
                        mov     ecx,dword ptr _cputraceptr
                        and     ecx,07ffffh
                        inc     dword ptr _cputracecount
                        inc     dword ptr _cputraceptr
                        mov     edx,dword ptr _pc
                        mov     dword ptr _cputracebuffer[4*ecx],edx
#ifdef PC_PTR
                        mov     edx,dword ptr _pcbaseadr
                        mov     dword ptr _cputracebase[4*ecx],edx
#endif
notrace2:
#endif
                        SET_POSITION_FULL _cpu_next
                        EXEC_NEXT_68K_TRACE
                        add     eax,dword ptr _thiscycle
			mov	ecx, dword ptr [_config_cpu_speed]
                        shr     eax, cl
                        add     eax,dword ptr [_thiscycle]
bus_debug_exception_ret:mov     dword ptr _thiscycle,0 
                        add     eax,dword ptr [_curcycle]
                        mov     dword ptr [_cpu_next],eax
                        NEXT_EVENT_AFTER_CPU bus_debug_loop_cpu, bus_debug_loop_events
                        ret

                        ALIGN32
bus_debug_loop_events:  NEXT_EVENT bus_debug_loop_cpu

                        ALIGN32
bus_debug_loop_events_start:  
			NEXT_EVENT bus_debug_start


;==========================================================
; When CPU traces, this routine is called.
; Prepare_exception will jmp back into the "fast" bus_loop
; or the debug loop, depending on what is set in
; exceptionbackdoors
;==========================================================

                        ALIGN32

tracebit_handler:       call    dword ptr [edi]           
                        mov     dword ptr _pc,esi        
                        mov     ebx,024h
                        jmp     prepare_exception_




;===========================================================
; Clean up after STOP was executed and enter bus_loop again 
;===========================================================


                        ALIGN32

public return_from_stop_
return_from_stop_:      mov     [_pc], esi
                        mov     dword ptr _thiscycle,0  
                        mov     dword ptr [_cpu_next],-1
                        jmp     dword ptr [_stopreturnadr]


;===================================================
; Wrappers for some emulation that was written in C
;===================================================


                        ALIGN32

public cia_handle_event_wrapper_
cia_handle_event_wrapper_:      jmp    cia_handle_event_


                        ALIGN32

public cia_setup_event_wrapper_
cia_setup_event_wrapper_:
                        push    ebx
                        push    eax
                        SCAN_EVENTS_LVL6
                        pop     eax
                        pop     ebx
                        ret


; =====================
; End of line handler
; =====================


		ALIGN32

public end_of_line_
end_of_line_:	push	edx
		push	ecx
		push	ebx

		test	dword ptr [_frameskip],0ffffffffh
		jnz	elframeskipped


		test	byte ptr [_config_draw_cycleexact],1
		jz	eolnocc
		test	byte ptr [_config_graphics_mode],0xff
		jnz	eolnocc
		call	cop_run_until_cycle_6_
eolnocc:
        

		playfieldonoff


		cmp	dword ptr _ypos,12h
		jb	elframeskipped

		; Here decode the sprites

		test	byte ptr _dmacon,020h
		jz	el3
		cmp	dword ptr [_ypos],18h
		jb	el3
		call	decodesprites_

		; Sprites decoded, spritesonlineflag is set if there are any

el3:
		update_drawmode

		TSC_BEFORE _drawptr_tsctmp

		call	dword ptr [_drawptr]

		TSC_AFTER _drawptr_tsctmp, _drawptr_tsc, _drawptr_tsctimes

		test	byte ptr [_bg2ddf],1
		jz	elframeskipped
		mov	edx,[_drawddfroutine]
		mov	[_drawptr],edx
		mov	byte ptr [_bg2ddf],0
elframeskipped:

		mov	ebx,dword ptr _spritewritenext
		test	ebx,ebx
		jz	elz
		push	eax
		xor	eax, eax
		mov	dword ptr [_spritewritenext],eax
		mov	dword ptr [_spritewritereal],1
elzl:		mov	ecx,dword ptr [_spritewritebuffer+eax]
		mov	edx,dword ptr [_spritewritebuffer+4+eax]
		and	ecx,01feh
		call	dword ptr [_iowrite+2*ecx]
		add	eax,8
		cmp	eax,ebx
		jne	elzl
		pop	eax
elz:
		mov	dword ptr [_spritewritereal],0

		mov	eax,1
		call    cia_update_eventcounter_

		; Check for disk dma in progress

		cmp	byte ptr [_floppy_DMA_started], 1
		jne	el7
		cmp	byte ptr [_floppy_DMA_read], 1
		jne	elba
		pushad
		call	floppyDMARead_
		popad
		jmp	el7
elba:
		pushad
		call	floppyDMAWrite_
		popad
el7:
		cmp	byte ptr [_sound_mode], SOUND_NONE
		je	el4
		cmp	byte ptr [_sound_mode], SOUND_CONTIGUOUS
		jne	el15
		mov	edx,dword ptr [_audio_hblanks]
		sub	dword ptr [_audio_hblanks],edx
		cmp	edx,100          ; Try to prevent too much accumulation
		jb	el20
		mov	edx, 5
el20:
		test	edx,edx
		jz	el4
el16:		push	edx
		call	dword ptr [_soundFrequencyHandlerCallback]
		pop	edx
		inc	dword ptr [_audio_hblanks_thisbuffer]
		cmp	dword ptr [_audio_hblanks_thisbuffer], 2817
		je	el17
el17a:		dec	edx
		jnz	el16
		jmp	el4
el17:		push	edx
		mov	edx, dword ptr [_sound_buffer_depth_eol_index]
		mov	dword ptr [_audio_hblanks_thisbuffer],edx
		call	soundBufferPlay_
		pop	edx
		mov	ebx,dword ptr _frames
;		mov	dword ptr _sbframe,ebx
		jmp	el17a
el15:		call	dword ptr [_soundFrequencyHandlerCallback]
el4:
		KEYBOARD_QUEUEHANDLER
		add	dword ptr [_eol_next],CYCLESPERLINE
		SCAN_EVENTS_LVL3
		pop	ebx
		pop	ecx
		pop	edx
		ret


;==============================================================
; This only happens 50 times per second, so maybe just as well
; write this in C.
;==============================================================


		ALIGN32

public end_of_frame_
end_of_frame_:	push	edx
		push	ebx
		cmp	byte ptr [_f12pressed], 1	; Exit on F12 press 
		jne	eofnf12
		mov	dword ptr [_debugging], 1
		mov	byte ptr [_f12pressed], 0
eofnf12:	xor	dword ptr [_lof], 08000h	; Short/long frame 
		xor	edx, edx
		mov	ecx, 0102h			; Zero scroll
		call	dword ptr [_iowrite + 2*ecx]
		cmp	byte ptr [_newvmode], 0		; Host mode changed 
		je	nonewvmode			; with keyb-shortcut 
		pushad
		call	soundEmulationStopping_
		call	setup_emu_videomode_
		call	soundEmulationStarting_
		popad
		mov	dword ptr [_newvmode], 0
nonewvmode:	cmp	byte ptr [_center_code], 0	; Manual view scroll
		je	nocenter
		pushad
		call	do_center_
		popad
nocenter:	test	dword ptr [_frameskip], -1	; Switch buffers
		jnz	skipped
		cmp	dword ptr [_config_printspeed], 1
		jne	nah
		pushad
		call	draw_speed_
		popad
nah:		push	eax
		call	draw_switchbuffer_
		pop	eax
skipped:	cmp	byte ptr [_BMPdumpflag], 1	; Dump BMP image
		jne	eofnobmpdump
		pushad
		call	BMPImageDump_
		popad
eofnobmpdump:	call	copper_restart_			; Restart copper
		inc	dword ptr [_frames]		; Count frames
		dec	dword ptr [_frameskip]		; Frame skipping
		jns	doe1
		mov	edx, dword ptr [_config_graphics_skiprate]
		mov	dword ptr [_frameskip], edx
doe1:		call	cia_update_timers_eof_		; Timers/eventcounter
		mov	edx, dword ptr [_sound_framecounter]
		inc	edx				; Play sound
		mov	dword ptr [_sound_framecounter], edx
		cmp	edx, dword ptr [_sound_buffer_depth]
		jb	blargh
		mov	dword ptr [_sound_framecounter], 0
		cmp	byte ptr [_config_printspeed], 1; Print speed counter 
		jne	noprintspeed
		pushad
		call	print_emuspeed_
		popad
noprintspeed:	cmp	dword ptr [_sound_mode], SOUND_NONE; use timersynch
		je	eofwaittimer
		cmp	dword ptr [_sound_mode], SOUND_PLAY; use sndirq synch
		je	eofps
		cmp	dword ptr [_sound_mode], SOUND_EMULATE
		jne	eofwaittimer			   ; check timersynch
eofps:		call	soundBufferPlay_
		mov	edx, dword ptr [_frames]
; 		mov	dword ptr [_sbframe], edx
		jmp	blargh
eofwaittimer:	cmp	dword ptr [_config_graphics_maxfps], 1
		jne	blargh
eofwt:							; Timer synch enabled 
ttck:		mov	edx, dword ptr [_sound_buffer_depth]
		cmp	dword ptr [_tick], edx
		jb	eofwt
		mov	dword ptr [_tick], 0
blargh:
		; generate FLAG int (INDEX)  every 16th frame.
		; just to keep some loaders happy

		mov	edx, [_frames]
        and     edx,01fh
        jnz     haya
        mov     eax,1
        mov     edx,010h
        call    cia_raise_irq_
haya:

        mov     edx,dword ptr _frames
        and     edx,7
        jnz     nojoy
#ifdef WITH_OS_JOYSTICK
        pushad
        call    read_joysticks_
        popad
#endif
nojoy:
        ; generate dsksync value int every 8th frame unless
        ; disk dma is working, lets see what
        ; good it does

        cmp     dword ptr [_floppy_DMA_started], 1
        je      burp

        mov     edx,dword ptr _frames
        and     edx,7h
        jnz     burp
        mov     edx,09000h
        mov     ecx,0dff09ch
        writew
burp:
        xor     ecx,ecx
        mov     edx,offset _spritestate
        mov     dword ptr [edx],ecx
        mov     dword ptr 4[edx],ecx
        mov     dword ptr 8[edx],ecx
        mov     dword ptr 12[edx],ecx
        mov     dword ptr 16[edx],ecx
        mov     dword ptr 20[edx],ecx
        mov     dword ptr 24[edx],ecx
        mov     dword ptr 28[edx],ecx

        mov     dword ptr _playfieldon,ecx
        test    dword ptr [_blitend],0ffffffffh
        js      noblitmess
        sub     dword ptr _blitend,CYCLESPERFRAME
        jns     noblitmess
        mov     dword ptr _blitend,0
noblitmess:

        mov     edx,08020h
        call    dword ptr [_iowrite+0138h]

        cmp     dword ptr [_softreset],7
        jne     noreset
        pushad
        call    fellow_softreset_
        popad
noreset:
        mov     dword ptr [_eol_next],CYCLESPERLINE
        dec     dword ptr [_eol_next]

        mov     ebx,dword ptr [_cpu_next]
        test    ebx,ebx
        js      nrs1
        sub     ebx,CYCLESPERFRAME
        mov     dword ptr [_cpu_next],ebx
nrs1:
        mov     ebx,dword ptr [_irq_next]
        test    ebx,ebx
        js      nrs2
        sub     ebx,CYCLESPERFRAME
        mov     dword ptr [_irq_next],ebx
nrs2:
        SCAN_EVENTS_LVL6

        test    dword ptr [_debugging],1
        jz      emstop
        mov     esp,[_exceptionstack]
        jmp     bus_exit
emstop:

        pop     ebx
	pop     edx
        ret


        ALIGN32

_TEXT ends

_DATA segment dword public 'DATA'

include data\fellow.inc
include data\68000.inc
include data\bus.inc
include data\memory.inc
include data\draw.inc
include data\floppy.inc
include data\sound.inc
include data\inout.inc
include data\graphem.inc
include data\cianew.inc
include data\sblast.inc
include data\keyboard.inc
include data\copper.inc
include data\blit.inc
include data\BMP.inc
		
public _vgatest_time
_vgatest_time:  dd      0


#ifdef TSC_PROFILING
public _drawptr_tsc
public _drawptr_tsctimes
_drawptr_tsc:     dd      0,0
_drawptr_tsctmp:  dd      0,0
_drawptr_tsctimes:  dd      0

public _total_tsc
public _total_tsctimes
_total_tsc:     dd      0,0
_total_tsctmp:  dd      0,0
_total_tsctimes:  dd      0

#endif

extern _t:dword




public _bus_blitter_delay
_bus_blitter_delay:     db      0,1,0,0


_DATA ends

_BSS segment dword public 'DATA'
_BSS ends
end

