extern ULO draw_startoffset[3];
extern ULO draw_scanlinemodulo;
extern ULO draw_buffershow, draw_bufferdraw;


extern char *draw_framebuffer[3];
extern ULO draw_effectiveheight;
extern ULO draw_linefullwidth;
extern ULO config_draw_framebuffers;

extern ULO config_draw_cycleexact;

extern ULO scanlinelength;

struct gm_modelist {
  struct gm_modelist *next;
  ULO type;
  ULO width;
  ULO height;
  ULO bits;
  ULO modenr;           /* Used by VESA */
  ULO redsize;          /* Used in truecolor modes */
  ULO redpos;           
  ULO greensize;
  ULO greenpos;
  ULO bluesize;
  ULO bluepos;
  char name[80];        /* Name used in user-interfaces etc. */
};

#define GM_SCREEN 0
#define GM_WINDOW 1

extern struct gm_modelist *draw_modelist;
extern void draw_add_modelist_node(struct gm_modelist *node);
extern struct gm_modelist *draw_alloc_modelist_node(void);
extern void draw_print_modelist(void);


extern void drawstart(void); /* Code alignment check label */

extern ULO cliptop, clipbot, clipleftx, cliprightx;
extern ULO frames, frameskip;

extern draw_routine_ptr drawptr;
extern draw_routine_ptr drawbgroutine;
extern draw_routine_ptr drawroutineptr;
extern draw_routine_ptr drawloresroutine;
extern draw_routine_ptr drawhiresroutine;
extern draw_routine_ptr drawdualhiresroutine;
extern draw_routine_ptr drawdualloresroutine;
extern draw_routine_ptr drawhamroutine;
extern draw_routine_ptr drawddfroutine;

extern void fillbg800w(ULO);
extern void drawbgline800w(void);
extern void drawlores800w(void);
extern void drawhires800w(void);
extern void drawduallores800w(void);
extern void drawdualhires800w(void);
extern void drawham(void);

extern void drawbgline800wmmx(void);
extern void drawbgline800wCC(void);
extern void drawlores800wmmx(void);
extern void drawlores800wCC(void);
extern void drawlores800wmmxCC(void);
extern void drawhires800wmmx(void);
extern void drawhires800wCC(void);
extern void drawhires800wmmxCC(void);
extern void drawduallores800wmmx(void);


extern void fillbg640w(ULO);
extern void drawbgline640w(void);
extern void drawlores640w(void);
extern void drawhires640w(void);
extern void drawduallores640w(void);
extern void drawdualhires640w(void);
extern void drawham640w(void);

extern void fillbg320w(ULO);
extern void drawbgline320w(void);
extern void drawlores320w(void);
extern void drawlores320wmmx(void);
extern void drawduallores320w(void);
extern void drawham320w(void);

extern void drawlores320b(void);
extern void drawhires320b(void);
extern void drawduallores320b(void);
extern void drawham320b(void);
extern void drawbgline320b(void);

extern void drawddfline(void);
extern void drawddfline800wCC(void);
extern void drawddfline640w(void);
extern void drawddfline320w(void);
extern void drawddfline320b(void);


extern void init_drawtables_800w(void);
extern void init_drawtables_640w(void);
extern void init_drawtables_320w(void);
extern void init_drawtables_320b(void);

extern ULO bg2ddf;

#ifdef TSC_PROFILING
extern __int64 drawptr_tsc;
extern ULO drawptr_tsctimes;

extern __int64 drawbgline800_tsc;
extern ULO drawbgline800_tsctimes;

extern __int64 drawbgline800mmx_tsc;
extern ULO drawbgline800mmx_tsctimes;

extern __int64 drawbgline800notdrawn_tsc;
extern ULO drawbgline800notdrawn_tsctimes;

extern __int64 drawlores800_tsc;
extern ULO drawlores800_tsctimes;

extern __int64 drawlores800mmx_tsc;
extern ULO drawlores800mmx_tsctimes;

extern __int64 drawhires800_tsc;
extern ULO drawhires800_tsctimes;

extern __int64 drawhires800mmx_tsc;
extern ULO drawhires800mmx_tsctimes;

extern void dbgloopmmx(void);
extern void dbgnodrawmmx(void);
extern void dlloopmmx(void);
#endif

